<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: PathHandler Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classPathHandler-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PathHandler Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Handle path matching for an incoming HTTP request.  
 <a href="classPathHandler.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="HttpServer_8h_source.html">HttpServer.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2fd73ffd5f17f9a0de2f8bd89b4437c2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPathHandler.html#a2fd73ffd5f17f9a0de2f8bd89b4437c2">PathHandler</a> (std::string method, std::string pathPattern, void(*pWebServerRequestHandler)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse))</td></tr>
<tr class="memdesc:a2fd73ffd5f17f9a0de2f8bd89b4437c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct an instance of a <a class="el" href="classPathHandler.html" title="Handle path matching for an incoming HTTP request.">PathHandler</a>.  <a href="#a2fd73ffd5f17f9a0de2f8bd89b4437c2">More...</a><br /></td></tr>
<tr class="separator:a2fd73ffd5f17f9a0de2f8bd89b4437c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af959d3f50d33d3be44af827a93662720"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPathHandler.html#af959d3f50d33d3be44af827a93662720">PathHandler</a> (std::string method, std::regex *pathPattern, void(*pWebServerRequestHandler)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse))</td></tr>
<tr class="memdesc:af959d3f50d33d3be44af827a93662720"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct an instance of a <a class="el" href="classPathHandler.html" title="Handle path matching for an incoming HTTP request.">PathHandler</a>.  <a href="#af959d3f50d33d3be44af827a93662720">More...</a><br /></td></tr>
<tr class="separator:af959d3f50d33d3be44af827a93662720"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a50a3baba682292270f79b3a435cc4c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPathHandler.html#a5a50a3baba682292270f79b3a435cc4c">match</a> (std::string method, std::string path)</td></tr>
<tr class="memdesc:a5a50a3baba682292270f79b3a435cc4c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Determine if the path matches.  <a href="#a5a50a3baba682292270f79b3a435cc4c">More...</a><br /></td></tr>
<tr class="separator:a5a50a3baba682292270f79b3a435cc4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5f06052f99f675aef8ccea42b7cd09f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPathHandler.html#ae5f06052f99f675aef8ccea42b7cd09f">invokePathHandler</a> (<a class="el" href="classHttpRequest.html">HttpRequest</a> *request, <a class="el" href="classHttpResponse.html">HttpResponse</a> *response)</td></tr>
<tr class="memdesc:ae5f06052f99f675aef8ccea42b7cd09f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Invoke the handler.  <a href="#ae5f06052f99f675aef8ccea42b7cd09f">More...</a><br /></td></tr>
<tr class="separator:ae5f06052f99f675aef8ccea42b7cd09f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Handle path matching for an incoming HTTP request. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a2fd73ffd5f17f9a0de2f8bd89b4437c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2fd73ffd5f17f9a0de2f8bd89b4437c2">&#9670;&nbsp;</a></span>PathHandler() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PathHandler::PathHandler </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>method</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>matchPath</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse)&#160;</td>
          <td class="paramname"><em>pWebServerRequestHandler</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct an instance of a <a class="el" href="classPathHandler.html" title="Handle path matching for an incoming HTTP request.">PathHandler</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">method</td><td>The method to be matched. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pathPattern</td><td>The path to be matched. Must be an exact match. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">webServerRequestHandler</td><td>The request handler to be called. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af959d3f50d33d3be44af827a93662720"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af959d3f50d33d3be44af827a93662720">&#9670;&nbsp;</a></span>PathHandler() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PathHandler::PathHandler </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>method</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::regex *&#160;</td>
          <td class="paramname"><em>pRegex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse)&#160;</td>
          <td class="paramname"><em>pWebServerRequestHandler</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct an instance of a <a class="el" href="classPathHandler.html" title="Handle path matching for an incoming HTTP request.">PathHandler</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">method</td><td>The method to be matched. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pathPattern</td><td>The path pattern to be matched. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">webServerRequestHandler</td><td>The request handler to be called. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae5f06052f99f675aef8ccea42b7cd09f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae5f06052f99f675aef8ccea42b7cd09f">&#9670;&nbsp;</a></span>invokePathHandler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PathHandler::invokePathHandler </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classHttpRequest.html">HttpRequest</a> *&#160;</td>
          <td class="paramname"><em>request</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classHttpResponse.html">HttpResponse</a> *&#160;</td>
          <td class="paramname"><em>response</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Invoke the handler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">request</td><td>An object representing the request. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">response</td><td>An object representing the response. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a5a50a3baba682292270f79b3a435cc4c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5a50a3baba682292270f79b3a435cc4c">&#9670;&nbsp;</a></span>match()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PathHandler::match </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>method</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>path</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Determine if the path matches. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">method</td><td>The method to be matched. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">path</td><td>The path to be matched. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if the path matches. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="HttpServer_8h_source.html">HttpServer.h</a></li>
<li>HttpServer.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
